property soundChannel, constraintsprite, initialvolume, spriteNum, mySprite, myActiveFlag, myDirection, mybounds, myclickoffset, plastvol

on beginSprite me
  mySprite = sprite(spriteNum)
  myActiveFlag = 0
  inlist = me.insidespritelist(spriteNum)
  if getPos(inlist, constraintsprite) = 0 then
    constraintsprite = 0
  end if
  if constraintsprite = 0 then
    boundrect = (the stage).rect
    boundrect = offset(boundrect, -boundrect.left, -boundrect.top)
  else
    boundrect = sprite(constraintsprite).rect
  end if
  boundwidth = boundrect.width
  boundheight = boundrect.height
  if boundwidth > boundheight then
    mybounds = [#min: boundrect.left + mySprite.locH - mySprite.left, #max: boundrect.right + mySprite.locH - mySprite.right]
    mybounds[#range] = mybounds.max - mybounds.min
    myDirection = #horizontal
  else
    mybounds = [#min: boundrect.top + mySprite.locV - mySprite.top, #max: boundrect.bottom + mySprite.locV - mySprite.bottom]
    mybounds[#range] = mybounds.max - mybounds.min
    myDirection = #vertical
  end if
  sound(soundChannel).volume = initialvolume
  plastvol = sound(soundChannel).volume
  newLoc = mybounds.range * initialvolume / 255
  case myDirection of
    #horizontal:
      mySprite.locH = mybounds.min + newLoc
    #vertical:
      mySprite.locV = mybounds.max - newLoc
  end case
end

on mouseUpOutSide me
  myActiveFlag = 0
end

on mouseDown me
  myclickoffset = the clickLoc - sprite(spriteNum).loc
  myActiveFlag = 1
end

on mouseUp me
  myActiveFlag = 0
end

on prepareFrame me
  if myActiveFlag then
    case myDirection of
      #horizontal:
        newLoc = (the mouseLoc).locH - myclickoffset.locH
      #vertical:
        newLoc = (the mouseLoc).locV - myclickoffset.locV
    end case
    if newLoc < mybounds.min then
      newLoc = mybounds.min
    else
      if newLoc > mybounds.max then
        newLoc = mybounds.max
      end if
    end if
    case myDirection of
      #horizontal:
        mySprite.locH = newLoc
      #vertical:
        mySprite.locV = newLoc
    end case
  end if
  case myDirection of
    #horizontal:
      offsetloc = mySprite.locH - mybounds.min
    #vertical:
      offsetloc = mybounds.max - mySprite.locV
  end case
  if myActiveFlag then
    sound(soundChannel).volume = 255 * offsetloc / mybounds.range
  else
    if sound(soundChannel).volume <> plastvol then
      newLoc = mybounds.range * sound(soundChannel).volume / 255
      case myDirection of
        #horizontal:
          mySprite.locH = mybounds.min + newLoc
        #vertical:
          mySprite.locV = mybounds.max - newLoc
      end case
    end if
  end if
  plastvol = sound(soundChannel).volume
end

on insidespritelist me, whichsprite
  spritelist = [0]
  thisSprite = sprite(whichsprite)
  repeat with i = 1 to whichsprite - 1
    case sprite(i).member.type of
      #animGif, #bitmap, #picture, #quickTimeMedia, #digitalVideo, #shape, #field, #filmLoop, #flash, #text, #movie, #vectorShape:
        if ((sprite(i).left < thisSprite.left) and (sprite(i).right > thisSprite.right)) or ((sprite(i).top < thisSprite.top) and (sprite(i).bottom > thisSprite.bottom)) then
          spritelist.add(i)
        end if
    end case
  end repeat
  return spritelist
end

on isOKToAttach me, aSpriteType, aSpriteNum
  isOK = 0
  case aSpriteType of
    #graphic:
      isOK = 1
  end case
  return isOK
end

on getPropertyDescriptionList me
  props = [:]
  props[#soundChannel] = [#comment: "Sound channel:", #format: #integer, #default: 1, #range: [1, 2, 3, 4, 5, 6, 7, 8]]
  props[#constraintsprite] = [#comment: "Constraining sprite (0 = the stage):", #format: #integer, #default: 0, #range: me.insidespritelist(the currentSpriteNum)]
  props[#initialvolume] = [#comment: "Initial sound volume:", #format: #integer, #default: 255, #range: [#min: 0, #max: 255]]
  return props
end

on getBehaviorTooltip me
  return "Turns sprite into a sliding 'thumb' for sound volume control."
end

on getBehaviorDescription me
  return "CHANNEL VOLUME SLIDER" & RETURN & RETURN & "Drop this behavior onto a graphic sprite to turn it into a sliding 'thumb' that controls the volume of a sound." & RETURN & RETURN & "Select the sound channel that the slider will control, the sprite that defines the movement of the slider, and the starting volume of the sound." & RETURN & RETURN & "This behavior can control sound channels 1 to 8 (multiple copies of the behavior can be used to control more than one channel at a time). " & "The sprite used as the 'thumb' moves horizontally or vertically, with the right or top position being the maximum volume position. " & "The direction of movement is defined by the sprite chosen as a constraint. " & "The constraint sprite must be in a lower-numbered channel than the 'thumb', and it must be at least slightly larger than the 'thumb'. " & "A constraint sprite that is wider than it is tall will cause the 'thumb' to move horizontally; a taller constraint sprite creates a vertical movement. " & "The stage may also be used as a constraint (and is the default if the chosen constraint has been moved, deleted, or resized). " & "The sound volume ranges from silent (0) to maximum (255)." & RETURN & RETURN & "PERMITTED MEMBER TYPES:" & RETURN & "Graphics." & RETURN & RETURN & "PARAMETERS:" & RETURN & "* Sound channel - determines which sound channel this slider controls." & RETURN & "* Constraining sprite - determines direction and distance of slider movement (setting of 0 uses stage for constraint)." & RETURN & "* Initial sound volume - volume used for sound channel when slider first appears."
end
