property err
global photoDL, logoDL, bioDL, layoutDL, ProNoteDL, saveMode, downloadList, gSep, defaultFolder

on doDownload
  abortSave = 0
  err = 0
  if (saveMode <> 0) and (saveMode <> 99) then
    case saveMode of
      1:
        destPath = baSysFolder("desktop") & defaultFolder & gSep
        if not baFolderExists(destPath) then
          checkError = baCreateFolder(destPath)
          if checkError = 0 then
            abortSave = 1
            alert("Unable to create folder" & QUOTE & defaultFolder & QUOTE & "on your desktop.  Download aborted.")
          end if
        end if
      2:
        FileObj = new(xtra("fileio"))
        x = displaySave(FileObj, "Select folder", "save here")
        if x = EMPTY then
          abortSave = 1
        else
          n = offset("save here", x)
          destPath = x.char[1..n - 1]
        end if
        FileObj = 0
    end case
    if not abortSave then
      temp = the itemDelimiter
      the itemDelimiter = gSep
      repeat with i = 1 to downloadList.count
        SourceFile = downloadList[i]
        endfile = the last item in SourceFile
        err = baCopyFileProgress(SourceFile, destPath & endfile, "Always+", "Downloading", "Cancel", 4)
        checkDLError(err, endfile)
      end repeat
      the itemDelimiter = temp
      if not baFileExists(destPath & "captions.doc") then
        endfile = "captions.doc"
        SourceFile = the moviePath & "Captions" & gSep & endfile
        err = baCopyFileProgress(SourceFile, destPath & endfile, "Always+", "Downloading", "Cancel", 4)
        checkDLError(err, endfile)
      end if
    end if
  end if
  saveMode = 99
  downloadList = []
  photoDL = []
  bioDL = []
  logoDL = []
  layoutDL = []
  ProNoteDL = []
  sendAllSprites(#resetHilite)
  sendAllSprites(#reSetSelect)
end

on checkDLError err, endfile
  case err of
    0:
      exit
    1:
      alert("Invalid Source File Name " & QUOTE & endfile & QUOTE)
    2:
      alert("Invalid Dest File Name " & QUOTE & endfile & QUOTE)
    3:
      alert("Error Reading Source File " & QUOTE & endfile & QUOTE)
    4:
      alert("Error Writing Dest File" & QUOTE & endfile & QUOTE)
    5:
      alert("Error Creating Directory " & QUOTE & defaultFolder & QUOTE)
    6:
      alert("Dest file " & QUOTE & endfile & QUOTE, " already exits")
    7:
      alert("Dest file " & QUOTE & endfile & QUOTE, " newer than Source File")
    9:
      alert("Copy Cancelled by User")
  end case
end
