property err
global photoDL, logoDL, bioDL, layoutDL, ProNoteDL, saveMode, downloadList, gSep, defaultFolder

on doDownload_old
  abortSave = 0
  err = 0
  if (saveMode <> 0) and (saveMode <> 99) then
    case saveMode of
      1:
        destPath = baSysFolder("desktop") & defaultFolder & gSep
        if not baFolderExists(destPath) then
          checkError = baCreateFolder(destPath)
          if checkError = 0 then
            abortSave = 1
            alert("Unable to create folder" & QUOTE & defaultFolder & QUOTE & "on your desktop.  Download aborted.")
          end if
        end if
      2:
        FileObj = new(xtra("fileio"))
        x = displaySave(FileObj, "Select folder", "save here")
        if x = EMPTY then
          abortSave = 1
        else
          n = offset("save here", x)
          destPath = x.char[1..n - 1]
        end if
        FileObj = 0
    end case
    if not abortSave then
      capFile = new(xtra("FileIO"))
      openFile(capFile, destPath & "captions.txt", 2)
      if error(capFile, status(capFile)) = "OK" then
        setPosition(capFile, getLength(capFile))
      else
        createFile(capFile, destPath & "captions.txt")
        openFile(capFile, destPath & "captions.txt", 2)
      end if
      writeString(capFile, member("header.txt").text)
      writeString(capFile, the short time && the date & RETURN & RETURN & RETURN)
      writeString(capFile, "You have downloaded the following photo files:" & RETURN & RETURN)
      if photoDL.count then
        repeat with i = 1 to photoDL.count
          copyString = getCaption(photoDL[i])
          writeString(capFile, copyString & RETURN & RETURN)
        end repeat
      end if
      writeString(capFile, member("copyright.txt").text)
      closeFile(capFile)
      capFile = 0
      temp = the itemDelimiter
      the itemDelimiter = gSep
      repeat with i = 1 to downloadList.count
        SourceFile = downloadList[i]
        endfile = the last item in SourceFile
        err = baCopyFileProgress(SourceFile, destPath & endfile, "Always+", "Downloading", "Cancel", 4)
      end repeat
      the itemDelimiter = temp
      case err of
        0:
          saveMode = 99
          downloadList = []
          photoDL = []
          bioDL = []
          logoDL = []
          layoutDL = []
          ProNoteDL = []
          sendAllSprites(#resetHilite)
          sendAllSprites(#reSetSelect)
        1:
          alert("Invalid Source File Name " & QUOTE & endfile & QUOTE)
        2:
          alert("Invalid Dest File Name " & QUOTE & endfile & QUOTE)
        3:
          alert("Error Reading Source File " & QUOTE & endfile & QUOTE)
        4:
          alert("Error Writing Dest File" & QUOTE & endfile & QUOTE)
        5:
          alert("Error Creating Directory " & QUOTE & defaultFolder & QUOTE)
        6:
          alert("Dest file " & QUOTE & endfile & QUOTE, " already exits")
        7:
          alert("Dest file " & QUOTE & endfile & QUOTE, " newer than Source File")
        9:
          alert("Copy Cancelled by User")
      end case
    end if
  end if
end

on getCaption photoindex
  captions = member("captions").text
  totalLines = captions.line.count
  capText = EMPTY
  n = 0
  repeat with i = 1 to totalLines
    if photoindex = captions.line[i].word[1] then
      n = i
      exit repeat
    end if
  end repeat
  if n then
    goNext = 1
    repeat while goNext
      i = i + 1
      if (captions.line[i].word[1] = "(c)") or (captions.line[i].word[i] = "©") then
        m = i - 1
        goNext = 0
      end if
    end repeat
  end if
  capText = captions.line[n..m]
  return capText
end
